package org.rzo.yacron4j.example;

import java.text.ParseException;
import java.util.Date;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

import org.rzo.yacron4j.Scheduler;
import org.rzo.yacron4j.TaskOptions;

public class CancelExecution
{

	/**
	 * @param args
	 * @throws ParseException
	 */
	public static void main(String[] args) throws Exception
	{
		Scheduler scheduler = new Scheduler();
		String cronExpression = "0/1 * * * * ?";
		TaskOptions options = new TaskOptions();
		options.setAllowOverlap(true); // allow execution of same task to
										// overlap
		ScheduledFuture task = scheduler.schedule(new Runnable()
		{

			public void run()
			{
				System.out.println("" + new Date() + " running "
						+ Thread.currentThread().getName());
				try
				{
					Thread.sleep(5000);
				}
				catch (InterruptedException e)
				{
					e.printStackTrace();
				}
			}
		}, cronExpression, options);
		System.out.println(new Date(System.currentTimeMillis()
				+ task.getDelay(TimeUnit.MILLISECONDS)));
		Thread.sleep(15000);
		task.cancel(true);
		Thread.sleep(15000);
		scheduler.shutdown();
	}

}
